# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class WorkerScript(pulumi.CustomResource):
    content: pulumi.Output[str]
    """
    The script content.
    """
    kv_namespace_bindings: pulumi.Output[list]
    name: pulumi.Output[str]
    """
    The name for the binding.
    """
    def __init__(__self__, resource_name, opts=None, content=None, kv_namespace_bindings=None, name=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a Cloudflare worker script resource. In order for a script to be active, you'll also need to setup a `.WorkerRoute`.

        ## Example Usage



        ```python
        import pulumi
        import pulumi_cloudflare as cloudflare

        my_namespace = cloudflare.WorkersKvNamespace("myNamespace", title="example")
        # Sets the script with the name "script_1"
        my_script = cloudflare.WorkerScript("myScript",
            name="script_1",
            content=(lambda path: open(path).read())("script.js"),
            kv_namespace_binding=[{
                "name": "my_binding",
                "namespaceId": my_namespace.id,
            }])
        ```


        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] content: The script content.
        :param pulumi.Input[str] name: The name for the binding.

        The **kv_namespace_bindings** object supports the following:

          * `name` (`pulumi.Input[str]`) - The name for the binding.
          * `namespace_id` (`pulumi.Input[str]`) - ID of KV namespace.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if content is None:
                raise TypeError("Missing required property 'content'")
            __props__['content'] = content
            __props__['kv_namespace_bindings'] = kv_namespace_bindings
            if name is None:
                raise TypeError("Missing required property 'name'")
            __props__['name'] = name
        super(WorkerScript, __self__).__init__(
            'cloudflare:index/workerScript:WorkerScript',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, content=None, kv_namespace_bindings=None, name=None):
        """
        Get an existing WorkerScript resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] content: The script content.
        :param pulumi.Input[str] name: The name for the binding.

        The **kv_namespace_bindings** object supports the following:

          * `name` (`pulumi.Input[str]`) - The name for the binding.
          * `namespace_id` (`pulumi.Input[str]`) - ID of KV namespace.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["content"] = content
        __props__["kv_namespace_bindings"] = kv_namespace_bindings
        __props__["name"] = name
        return WorkerScript(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

